import sqlalchemy
import sqlalchemy.orm
from . import _base
from .printJobProperty import PrintJobProperty


class PrintJob(_base.Base):
    __tablename__ = "job"

    id = sqlalchemy.Column(sqlalchemy.Integer, primary_key=True)
    name = sqlalchemy.Column(sqlalchemy.String)
    filename = sqlalchemy.Column(sqlalchemy.String)
    state = sqlalchemy.Column(sqlalchemy.String, index=True)
    # The uuid is generated by the printer when a job is started.
    uuid = sqlalchemy.Column(sqlalchemy.String)

    # Setup the one-to-one relationship of an active job on a printer.
    active_printer = sqlalchemy.orm.relationship("Printer", uselist=False, back_populates="current_job")

    # Setup the one-to-many relationship of properties on this job
    properties = sqlalchemy.orm.relationship("PrintJobProperty", back_populates="job", cascade="all, delete, delete-orphan")

    def getPropertyValue(self, key):
        for p in self.properties:
            if p.key == key:
                return p.value
        return None

    def setPropertyValue(self, key, value):
        for p in self.properties:
            if p.key == key:
                p.value = value
                return
        self.properties.append(PrintJobProperty(key=key, value=value))
